﻿@page "/vacationtype"
@using VacationSchedule.Core.Models.DB;
@inject HttpClient Http

<PageTitle>VacationType</PageTitle>

<h1>Виды отдыха</h1>

@if (vacationTypes == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>Вид отдыха</th>
                <th>Действия</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var vType in vacationTypes)
            {
                <tr>
                    <td>@vType.Name</td>
                    <td></td>
                </tr>
            }
            <tr>
                <td>
                    <input type="text" class="form-control" placeholder="Наименование подразделения" @bind="newType.Name"/>
                </td>
                <td>
                    <button class="btn btn-primary" @onclick="@(e => AddType(newType))">Add</button>
                </td>
            </tr>
        </tbody>
    </table>
}

@code {
    private VacationType[] vacationTypes;
    private VacationType newType;

    protected override async Task OnInitializedAsync()
    {
        await RefreshTypes();
    }

    private async Task RefreshTypes()
    {
        vacationTypes = await Http.GetFromJsonAsync<VacationType[]>("api/VacationType");
        newType = NewType();
    }

    private async Task AddType(VacationType dep)
    {
        await Http.PostAsJsonAsync<VacationType>($"api/VacationType", dep);
        await RefreshTypes();
    }

    private VacationType NewType() => new();

}
